<template>
  <div class="row">
    <div class="col-5">
      <q-draggable
        ref="baseDraggable"
        :selected.sync="baseSelected"
        :value="baseList"
        :mode="mode"
        @input="$emit('update:baseList',$event)"
        :title="baseTitle"
        :label-attr="labelAttr"
        :name-attr="nameAttr"
      />
    </div>

    <div class="col-2 q-pt-md">
      <div class="row q-mt-lg q-pt-lg">
        <div class="col-12 text-center q-mt-lg">
          <q-btn @click="onMoveRight()" :color="(hasBase && hasBaseSelected) ? 'black' : 'grey'"
                 :disable="!hasBase || !hasBaseSelected"
                 stretch class="text-center" icon="la la-angle-right" dense flat>
            <q-tooltip v-if="hasBase && hasBaseSelected">Envoyer à droite</q-tooltip>
          </q-btn>
        </div>
      </div>

      <div class="row q-mt-md ">
        <div class="col-12 text-center">
          <q-btn @click="onMoveAllRight()"
                 :disable="!hasBase" :color="hasBase ? 'black' : 'grey'"
                 stretch class="text-center" icon="la la-angle-double-right" dense
                 flat>
            <q-tooltip v-if="hasBase">Envoyer tout à droite</q-tooltip>
          </q-btn>
        </div>
      </div>
      <div class="row q-mt-md ">
        <div class="col-12 text-center">
          <q-btn
            @click="onMoveLeft()"
            :disable="!hasTarget || !hasTargetSelected"
            stretch dense flat
            :color="(hasTarget && hasTargetSelected) ? 'black' : 'grey'"
            class="text-center" icon="la la-angle-left"
          >
            <q-tooltip v-if="hasTarget && hasTargetSelected">Envoyer à gauche</q-tooltip>
          </q-btn>
        </div>
      </div>
      <div class="row q-mt-md ">
        <div class="col-12 text-center">
          <q-btn
            @click="onMoveAllLeft()"
            :disable="!hasTarget"
            stretch dense flat
            :color="hasTarget ? 'black' : 'grey'"
            class="text-center" icon="la la-angle-double-left"
          >
            <q-tooltip v-if="hasTarget">Envoyer tout à gauche</q-tooltip>
          </q-btn>
        </div>
      </div>
    </div>

    <div class="col-5">
      <q-draggable
        ref="targetDraggable"
        :mode="mode"
        :selected.sync="targetSelected"
        :value="targetList"
        @input="$emit('update:targetList',$event)"
        :title="targetTitle"
        :label-attr="labelAttr"
        :name-attr="nameAttr"
      />
    </div>
  </div>
</template>

<script>
import draggable from 'vuedraggable'
import QDraggable from "components/datatables/QDraggable";
import MField from "components/forms/MField";
import ModeMixin from "src/mixins/mode-mixin";

export default {
  name: 'QDoubleDraggable',
  components: {MField, QDraggable, draggable},
  mixins: [ModeMixin],
  props: {
    // base props
    baseList: {
      type: Array,
      default: () => []
    },
    baseTitle: {
      type: String,
    },
    // target props
    targetList: {
      type: Array,
      default: () => []
    },
    targetTitle: {
      type: String,
    },

    // common
    labelAttr: {
      type: String,
      default: 'description'
    },
    nameAttr: {
      type: String,
      default: 'slug'
    },
  },
  data() {
    return {
      baseSelected: [],
      targetSelected: []
    }
  },

  methods: {
    /**
     *  permet de déplacer la liste des éléments sélection de la liste de la liste de droit respectivement de gauche
     *  vers la gauche respectivement vers la droite
     *  Si aucun n'est selectionné  sera desactivé.
     * @param {boolean} target
     */
    onMove(target) {
      if (target) {
        const data = this.baseList.filter((row) =>
          !this.baseSelected
            .some(it => it[this.nameAttr] === row[this.nameAttr]));
        this.$emit('update:baseList', data);
        this.$emit('update:targetList', [...this.baseSelected, ...this.targetList])
        this.baseSelected = [];
      } else {
        const data = this.targetList.filter((row) =>
          !this.targetSelected
            .some(it => it[this.nameAttr] === row[this.nameAttr]));
        this.$emit('update:targetList', data);
        this.$emit('update:baseList', [...this.targetSelected, ...this.baseList])
        this.targetSelected = [];
      }

    },
    /**
     *  permet de déplacer la liste des éléments filtre de la liste de la liste de droit respectivement de gauche
     *  vers la gauche respectivement vers la droite
     *  Si aucun n'est filtré ces sera toute la liste qui sera envoyé.
     *
     *
     * @param {boolean} target
     */
    onMoveAll(target) {
      const listFiltered = [].concat(target ? this.$refs.baseDraggable.listFiltered : this.$refs.targetDraggable.listFiltered);
      this.$emit(`update:${target ? 'baseList' : 'targetList'}`, target ?
        this.baseList.filter((row) => !listFiltered.some(it => it[this.nameAttr] === row[this.nameAttr])):
        this.targetList.filter((row) => !listFiltered.some(it => it[this.nameAttr] === row[this.nameAttr]))
      );
      this.$emit(`update:${target ? 'targetList' : 'baseList'}`,
        target ? [...listFiltered, ...this.targetList] :
          [...listFiltered, ...this.baseList]
      );
    },
    onMoveRight() {
      this.onMove(true);
    },
    onMoveAllRight() {
      this.onMoveAll(true);
    },
    onMoveLeft() {
      this.onMove(false);
    },
    onMoveAllLeft() {
      this.onMoveAll(false);
    }
  },

  computed: {
    hasBaseSelected(){
      return this.baseSelected.length > 0;
    },
    hasTargetSelected(){
      return this.targetSelected.length > 0;
    },
    hasBase(){
      return this.baseList.length > 0;
    },
    hasTarget(){
      return this.targetList.length > 0;
    }
  },
  mounted() {
    console.log('To God Be the Glory')
  }
}
</script>

